#include "stdafx.h"
#include "Rootfly.h"
#include "RootflyDlg.h"

////////////////////////////////////////////////////////////////////////
// ModeHandlerMODE_STARTINGMOVEALL

void ModeHandlerMODE_STARTINGMOVEALL::OnMouseMove(UINT nFlags, CPoint point2)
{
  //no functionality
}

void ModeHandlerMODE_STARTINGMOVEALL::OnLButtonDown(UINT nFlags, CPoint point)
{
  m_dlg->m_previous_click_cpoint_for_undo = point;
  RPoint pt = m_dlg->m_converter.ClientToImage( point );
  //preserve the starting point of the move all
  m_dlg->m_controller.C_SetShowRootID(false); //fix clipping error
  m_dlg->m_last_mouse_move_point = CPoint(pt.x, pt.y);
  m_dlg->SetMode(MODE_MOVINGALLROOTS);
}

void ModeHandlerMODE_STARTINGMOVEALL::OnLButtonDblClk(UINT nFlags, CPoint point)
{
  //no functionality
}

void ModeHandlerMODE_STARTINGMOVEALL::OnRButtonDown(UINT nFlags, CPoint point)
{
  //no functionality
}

CString ModeHandlerMODE_STARTINGMOVEALL::GetStatusText()
{
  return "Left click to begin moving all roots";
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnMouseMove(UINT nFlags, CPoint cpoint)
{
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube() );
  assert(tube); if (!tube) return;
  const Root *tempr = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(tempr);  if (!tempr)  return;
  const RootInstance *inst = tempr->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  RPoint point = m_dlg->m_converter.ClientToImage(CPoint(cpoint.x,cpoint.y),tempr->GetPrimaryWindow());

  CString temp;
  CPoint last = m_dlg->m_last_mouse_move_point;
  //get session number
  m_dlg->m_edit_session.GetWindowText(temp);
  int session = atoi(temp);		
  m_dlg->m_controller.C_MoveRootSess( m_dlg->m_selected_root_id, session, point.x - last.x, point.y - last.y );   
  //update the new old point
  m_dlg->m_last_mouse_move_point = CPoint( point.x, point.y );
  m_dlg->ReDraw(1,0);
}

CString ModeHandlerMODE_MOVINGSINGLEROOT::GetStatusText()
{
  CString str;
  str += _T("Moving root, left click to finish");
  return str;
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// no functionality
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnLButtonDown(UINT nFlags, CPoint cpoint)
{
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube() );
  assert(tube); if (!tube) return;
  const Root *tempr = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(tempr);  if (!tempr)  return;
  const RootInstance *inst = tempr->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  RPoint point = m_dlg->m_converter.ClientToImage(CPoint(cpoint.x,cpoint.y),tempr->GetPrimaryWindow());

  RPoint undo_point = m_dlg->m_converter.ClientToImage( m_dlg->m_previous_click_cpoint_for_undo,tempr->GetPrimaryWindow());
  CString temp;
  CPoint last = m_dlg->m_last_mouse_move_point;
  //get session number
  m_dlg->m_edit_session.GetWindowText(temp);
  int session = atoi(temp);		
  m_dlg->m_controller.C_MoveRootSessU( m_dlg->m_selected_root_id, session, point.x - last.x, point.y - last.y, point.x - undo_point.x, point.y - undo_point.y );

  //finished moving root
  m_dlg->SetMode(MODE_IMAGEDISPLAYED);
  if (m_dlg->m_checkbox_show_root_ids.GetCheck() == BST_CHECKED)
  {
    m_dlg->m_controller.C_SetShowRootID(true);
  }
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnRButtonDown(UINT nFlags, CPoint point)
{
	// no functionality
}

//Group 2
//MODE_MOVINGALLROOTS
void ModeHandlerMODE_MOVINGALLROOTS::OnMouseMove(UINT nFlags, CPoint point2) 
{
  int window = m_dlg->m_app_data->GetWindow();
  RPoint point = m_dlg->m_converter.ClientToImage( point2,window);

  CPoint last = m_dlg->m_last_mouse_move_point;

	m_dlg->m_controller.C_MoveRootsInWindow(window, point.x - last.x, point.y - last.y);    

  //update the new old point
  m_dlg->m_last_mouse_move_point = CPoint( point.x, point.y );
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_MOVINGALLROOTS::OnLButtonDown(UINT nFlags, CPoint point2) 
{
  int window = m_dlg->m_app_data->GetWindow();
  RPoint point = m_dlg->m_converter.ClientToImage( point2,window);
  RPoint undo_point = m_dlg->m_converter.ClientToImage( m_dlg->m_previous_click_cpoint_for_undo,window);

  CPoint last = m_dlg->m_last_mouse_move_point;

	m_dlg->m_controller.C_MoveRootsInWindow_U(window, point.x - last.x, point.y - last.y, point.x - undo_point.x, point.y - undo_point.y);  

  //finished with move all
  m_dlg->SetMode(MODE_IMAGEDISPLAYED);
  if (m_dlg->m_checkbox_show_root_ids.GetCheck() == BST_CHECKED)
  {
    m_dlg->m_controller.C_SetShowRootID(true);
  }
  m_dlg->ReDraw(1,0);    
}

void ModeHandlerMODE_MOVINGALLROOTS::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
}

void ModeHandlerMODE_MOVINGALLROOTS::OnRButtonDown(UINT nFlags, CPoint point) 
{
}

CString ModeHandlerMODE_MOVINGALLROOTS::GetStatusText() 
{
  CString str;
  str += _T("Moving roots, left click to finish");
  return str;
}


//MODE_NOFILELOADED
void ModeHandlerMODE_NOFILELOADED::OnMouseMove(UINT nFlags, CPoint point) 
{
}
void ModeHandlerMODE_NOFILELOADED::OnLButtonDown(UINT nFlags, CPoint point) 
{
}
void ModeHandlerMODE_NOFILELOADED::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
}
void ModeHandlerMODE_NOFILELOADED::OnRButtonDown(UINT nFlags, CPoint point) 
{
}
CString ModeHandlerMODE_NOFILELOADED::GetStatusText() 
{ 
  CString str;
  str += _T("To begin, choose File->New or File->Open");
  return str; 
}

// group 3
void ModeHandlerMODE_DRAWINGNEWROOT::OnMouseMove(UINT nFlags, CPoint point) 
{
  SetCursor(m_dlg->m_cur_pen);
  m_dlg->ReDraw( 1, 0 );
}

void ModeHandlerMODE_DRAWINGNEWROOT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  vector<int> window_list;
  m_dlg->m_current_root_being_drawn.GetWindowNumbers(&window_list);
  RPoint temp = m_dlg->m_converter.ClientToImage(point);
  if(window_list.size() > 0)
    temp = m_dlg->m_converter.ChangeWindow(temp,window_list[0]);
  SetCursor(m_dlg->m_cur_pen);
  RPoint *rpt = m_dlg->m_current_root_being_drawn.CreatePoint();    
  assert(rpt); if( !rpt ) return;
  rpt->x = temp.x;
  rpt->y = temp.y;
  rpt->window = temp.window;       
  m_dlg->ReDraw(1, 0); 
}

void ModeHandlerMODE_DRAWINGNEWROOT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
  RDiameter *rdm;
  int window = m_dlg->m_app_data->GetWindow();
  RPoint conv_point = m_dlg->m_converter.ClientToImage( CPoint(point.x,point.y),window);
 
  while ( m_dlg->m_current_root_being_drawn.GetAllPoints()->size() < 2 ) 
  {
    //m_dlg->LeftClickWhileDrawingNewRoot( m_dlg->m_converter.ClientToImage( point ) );

    RPoint temp = m_dlg->m_converter.ClientToImage( point );
    SetCursor(m_dlg->m_cur_pen);
    RPoint *rpt = m_dlg->m_current_root_being_drawn.CreatePoint();    
    assert(rpt); if( !rpt ) return;
    rpt->x = temp.x;
    rpt->y = temp.y;
    rpt->window = temp.window;       
    m_dlg->ReDraw(1, 0);  
  }
  rdm = m_dlg->m_current_root_being_drawn.CreateDiameter();
  rdm->r_point.x = conv_point.x;
  rdm->r_point.y = conv_point.y;
  rdm->radius = 8;
  rdm->r_point.window = m_dlg->m_app_data->GetWindow();
  m_dlg->SetMode(MODE_LOCATINGDIAMETER); 
}

void ModeHandlerMODE_DRAWINGNEWROOT::OnRButtonDown(UINT nFlags, CPoint point) 
{
  ;
}

CString ModeHandlerMODE_DRAWINGNEWROOT::GetStatusText() 
{ 
  return "Left click to add point, double click to end root"; 
}


//Group 7
void ModeHandlerMODE_LOCATINGDIAMETER::OnMouseMove(UINT nFlags, CPoint point) 
{
  vector<int> window_list;
  m_dlg->m_current_root_being_drawn.GetWindowNumbers(&window_list);
  RPoint pt = m_dlg->m_converter.ClientToImage(point);

  RDiameter *rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0);
  RPoint temp = m_dlg->FindNearestPointOnRoot( pt, m_dlg->m_current_root_being_drawn);    
  temp = m_dlg->m_converter.ChangeWindow(temp,window_list[0]);
  rdm->r_point.x = temp.x;
  rdm->r_point.y = temp.y;
  rdm->r_point.window = temp.window; 
  rdm->radius = 8;    
  m_dlg->ReDraw(1, 0);   
}

void ModeHandlerMODE_LOCATINGDIAMETER::OnLButtonDown(UINT nFlags, CPoint point) 
{
  m_dlg->SetMode(MODE_SIZINGDIAMETER);       
  m_dlg->ReDraw(1, 0);
}

// This function should provide the same functionality as if the user were to
// LClick, then move mouse, then LClick.
// I.e., it should combine the functionality of the following two functions:
//     ModeHandlerMODE_SIZINGDIAMETER::OnMouseMove()
//     ModeHandlerMODE_SIZINGDIAMETER::OnLButtonDown()
// This is a shortcut, so its priority is low. -- STB 4/22/08
void ModeHandlerMODE_LOCATINGDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
//  std::vector<RPoint>::const_iterator r_iter;
//  RDiameter *rd2;
//  RPoint *rpt;  
//  RootInstance *r_inst;
//  const Root *root;  
//  const Tube *tube;
//  const std::vector<RPoint> *line;  
//  
//  RPoint conv_point, temp;
//  CRect main;
//  RDiameter *rdm;
//  rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0);
//      temp = m_dlg->FindNearestPointOnRoot( conv_point, m_dlg->m_current_root_being_drawn );
//      
//      rdm->r_point.x = temp.x;
//      rdm->r_point.y = temp.y;
//      rdm->r_point.window = temp.window;
//      rdm->radius = 8;
//      
//      tube = m_dlg->m_exp_data->GetTube( m_dlg->m_app_data->GetTube() );
//      if ( tube == NULL ) tube = m_dlg->m_controller.C_CreateTube(m_dlg->m_app_data->GetTube());
//      line = m_dlg->m_current_root_being_drawn.GetAllPoints();    
//      assert(line->size() > 0);
//      if (line->size() == 0)  return;
//      root = m_dlg->m_controller.C_CreateRoot( line->at(0).window );    
//      r_inst = m_dlg->m_controller.C_CreateRootInstance( root->GetID() );
//      assert( r_inst );    
//      for ( r_iter = line->begin(); r_iter != line->end(); r_iter++ )
//      {
//        rpt = r_inst->CreatePoint();
//		    *rpt = *r_iter;
////        rpt->x = r_iter->x;
////        rpt->y = r_iter->y;
////        rpt->window = r_iter->window;     
//      }
//      rd2 = m_dlg->m_controller.C_CreateDiameter( root->GetID() );
//      *rd2 = *rdm;
////      rd2->r_point.x = rdm->r_point.x;
////      rd2->r_point.y = rdm->r_point.y;
////      rd2->r_point.window = rdm->r_point.window;
////      rd2->radius = rdm->radius;
//      
//      // sets the default condition code for the root
//      m_dlg->SetConditionDefault(root);
//      
//      m_dlg->SetMode(MODE_IMAGEDISPLAYED);
//      m_dlg->m_current_root_being_drawn.ClearAll();
//      m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_LOCATINGDIAMETER::OnRButtonDown(UINT nFlags, CPoint point) 
{
  //empty
}
CString ModeHandlerMODE_LOCATINGDIAMETER::GetStatusText() 
{
  return "Left click to place diameter";
	
}

void ModeHandlerMODE_REPOSITIONDIAMETER::OnMouseMove(UINT nFlags, CPoint point2) 
{
  
  RPoint point = m_dlg->m_converter.ClientToImage( point2 );

  SetCursor(m_dlg->m_cur_closedhand);
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  RPoint temp = m_dlg->FindNearestPointOnRoot(point, *inst);
  temp = m_dlg->m_converter.ChangeWindow(temp,root->GetPrimaryWindow());
  //if ( temp.x < 0 || temp.y < 0) return;  //kept diameter form being moved to top window
  double dist = sqrt(pow((temp.x - point.x),2) + pow((temp.y - point.y),2));       
  if ( dist > 1.0 )  //keeps the diameter from walking around
  {
    m_dlg->m_controller.C_MoveDiameter(0, m_dlg->m_selected_root_id, temp);   
  } 
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_REPOSITIONDIAMETER::OnLButtonDown(UINT nFlags, CPoint point2) 
{
	RPoint point = m_dlg->m_converter.ClientToImage( point2 );

  SetCursor(m_dlg->m_cur_closedhand);
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  RPoint temp = m_dlg->FindNearestPointOnRoot(point, *inst);
  //CPoint temp2 = m_dlg->m_converter.ImageToClient(temp);  //convert point to different window
  //temp = m_dlg->m_converter.ClientToImage(temp2,root->GetPrimaryWindow());
  temp = m_dlg->m_converter.ChangeWindow(temp,root->GetPrimaryWindow());
  //if ( temp.x < 0 || temp.y < 0) return;  //kept diameter form being moved to top window
  double dist = sqrt(pow((temp.x - point.x),2) + pow((temp.y - point.y),2));       
  if ( dist > 1.0 )  //keeps the diameter from walking around
  {
    m_dlg->m_controller.C_MoveDiameter_U(0, m_dlg->m_selected_root_id, m_dlg->m_previous_diam_rpoint_for_undo, temp);   
  } 

    m_dlg->SetMode(MODE_ROOTSELECTED);          
    m_dlg->ReDraw(1, 0);

 }
 void ModeHandlerMODE_REPOSITIONDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point) {
 
 }
 void ModeHandlerMODE_REPOSITIONDIAMETER::OnRButtonDown(UINT nFlags, CPoint point) {
 
 }
 CString ModeHandlerMODE_REPOSITIONDIAMETER::GetStatusText() { 
   return "Moving diameter, left click to finish"; 
 }


// group 4 MODE_ROOTSELECTED
void ModeHandlerMODE_ROOTSELECTED::OnMouseMove(UINT nFlags, CPoint point_client)
{
  int window = m_dlg->m_app_data->GetWindow();
  RPoint point = m_dlg->m_converter.ClientToImage( CPoint(point_client.x,point_client.y),window);
  RDiameter nearest_point;
  nearest_point.radius = -1;
  m_dlg->FindNearestPoint( point.x, point.y, &nearest_point);   
  if ( nearest_point.radius < 0 )        
  {
    m_dlg->m_over_root = false;      
    m_dlg->UpdateStatusText();
  }
  else
  {
    m_dlg->m_over_root = true;   
    m_dlg->UpdateStatusText();
  }
  m_dlg->m_selected_index = m_dlg->GetSelectedIndex(CPoint( point.x, point.y ));    
  if ( m_dlg->m_selected_index == m_dlg->RESIZING_DIAMETER_SELECTED )
  {
    SetCursor(m_dlg->m_cur_sizens);
    m_dlg->UpdateStatusText();
  }
  else if ( m_dlg->m_selected_index == m_dlg->DIAMETER_SELECTED )
  {
    SetCursor(m_dlg->m_cur_openhand);
    m_dlg->UpdateStatusText();
  }
  else if ( m_dlg->m_selected_index == m_dlg->NOTHING_SELECTED )
  {
  }
  else if ( m_dlg->m_selected_index >= 0 )
  {
    SetCursor(m_dlg->m_cur_sizeall); 
    m_dlg->UpdateStatusText();
  }
}

void ModeHandlerMODE_ROOTSELECTED::OnLButtonDown(UINT nFlags, CPoint point_client)
{
  int window = m_dlg->m_app_data->GetWindow();
  RPoint point = m_dlg->m_converter.ClientToImage( CPoint(point_client.x,point_client.y),window);

  RDiameter nearest_point;
  m_dlg->FindNearestPoint( point.x, point.y, &nearest_point);      
  int selected_diameter = m_dlg->FindNearestDiameter(point.x, point.y);
  // Check to see if another root has been selected and change selected ID
  {
    bool clicked_point_of_selected_root = nearest_point.radius >= 0 && nearest_point.r_point.window == m_dlg->m_selected_root_id;
    bool clicked_diameter_of_selected_root = selected_diameter >= 0 && selected_diameter == m_dlg->m_selected_root_id;
    bool clicked_point_of_another_root = nearest_point.radius >= 0 && nearest_point.r_point.window != m_dlg->m_selected_root_id;
    bool clicked_diameter_of_another_root = selected_diameter >= 0 && selected_diameter != m_dlg->m_selected_root_id;
    if (!clicked_point_of_selected_root && !clicked_diameter_of_selected_root)
    {
      if (clicked_diameter_of_another_root) 
      {
        m_dlg->m_selected_root_id = selected_diameter;
        m_dlg->ReDraw(1,0);
        return;
      }
      else if (clicked_point_of_another_root) 
      {
        m_dlg->m_selected_root_id = nearest_point.r_point.window;  
        m_dlg->ReDraw(1,0);
        return;
      }
    }
  }
  // -1 means not over an interactive area of the root
  // -2 means over the diameter move area   (now moving the diameter)
  // -3 means over the diameter resize area (now resizing the diameter)   
  // all other indexes refer to points along the root (now moving a point)
  if (m_dlg->m_selected_index == m_dlg->RESIZING_DIAMETER_SELECTED) // -3
  {
    SetCursor(m_dlg->m_cur_sizens);

	  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
    assert(tube);  if (!tube)  return;
    const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
    assert(root);  if (!root)  return;
    const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
    assert(inst);  if (!inst)  return;
    const RDiameter *diam = inst->GetDiameter(0);
    assert(diam);  if (!diam)  return;
	  m_dlg->m_previous_radius_for_undo = diam->radius;

    m_dlg->SetMode(MODE_RESIZINGDIAMETER);
  }
  else if ( m_dlg->m_selected_index == m_dlg->DIAMETER_SELECTED )  // -2
  {
  	const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
    assert(tube);  if (!tube)  return;
    const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
    assert(root);  if (!root)  return;
    const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
    assert(inst);  if (!inst)  return;
    const RDiameter *diam = inst->GetDiameter(0);
    assert(diam);  if (!diam)  return;
	m_dlg->m_previous_diam_rpoint_for_undo = diam->r_point;

    SetCursor(m_dlg->m_cur_closedhand);
    m_dlg->SetMode(MODE_REPOSITIONDIAMETER);
  }
  else if ( m_dlg->m_selected_index >= 0 )
  {
	const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
    assert(tube);  if (!tube)  return;
    const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
    assert(root);  if (!root)  return;
    const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
    assert(inst);  if (!inst)  return;
	m_dlg->m_previous_root_for_undo = *inst;

    SetCursor(m_dlg->m_cur_sizeall);
	m_dlg->SetMode(MODE_MOVINGRPOINT); 
    m_dlg->UpdateDiameterPositionRatio();
  }
  else if (!m_dlg->m_over_root) 
  {
    // clicked off of root, it is no longer selected
    m_dlg->SetMode(MODE_IMAGEDISPLAYED);      
    m_dlg->m_selected_root_id = -1;
    m_dlg->m_selected_index = -1;       
    m_dlg->ReDraw(1, 0);
  }
  else
  {
	m_dlg->m_previous_click_cpoint_for_undo = point_client;

    //preserve the starting point of the move 
    m_dlg->m_controller.C_SetShowRootID(false); //fix clipping error
    m_dlg->m_last_mouse_move_point = CPoint(point.x, point.y);
    m_dlg->SetMode(MODE_MOVINGSINGLEROOT);
  }
}

void ModeHandlerMODE_ROOTSELECTED::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
  //empty, does nothing
}

void ModeHandlerMODE_ROOTSELECTED::OnRButtonDown(UINT nFlags, CPoint point) 
{
   if ( m_dlg->m_over_root )
   {
     // show context menu
     CMenu menu;
     menu.LoadMenu(IDR_MENU_CONTEXT);
     CMenu* popup;
     if( m_dlg->m_selected_index > -1 )  //Delete Button if Point clicked
     { 
       popup = menu.GetSubMenu(0);  
     }
     else   //Add Point Button if other part of root clicked
     {  
       const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
       assert(tube);  if (!tube)  return;
       const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
       assert(root);  if (!root)  return;
       const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
       assert(inst);  if (!inst)  return;
       popup = menu.GetSubMenu(1);  
       m_dlg->temporary_point_to_add = m_dlg->m_converter.ClientToImage(point);
       m_dlg->FindNearestPointOnRootSeg(m_dlg->temporary_point_to_add, *inst, &(m_dlg->section_start_point_index));  //Get segment to add point on
     }
     assert(popup != NULL);
     CPoint pt = point;
     m_dlg->ClientToScreen(&pt);
     popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, m_dlg );
     m_dlg->SetMode(MODE_IMAGEDISPLAYED); //keeps it in the right mode after closing the menu
   }
   return;
}

CString ModeHandlerMODE_ROOTSELECTED::GetStatusText() 
{ 
  CString str;
  switch( m_dlg->m_selected_index )
  {
    case -3:
      str+= _T("Left click to resize this diameter");
      break;
    case -2:
      str+= _T("Left click to move this diameter");
      break;
    case -1:
      if(m_dlg->m_over_root) str += _T("Left click to move root or right click to add a new point");
      else str += _T("Ready to modify root");
      break;
    default:
      str += _T("Left click to move this point, right click to delete");
  }
  return str;
}


// group 6
void ModeHandlerMODE_MOVINGRPOINT::OnMouseMove(UINT nFlags, CPoint point) 
{
  SetCursor(m_dlg->m_cur_sizeall);
  RPoint tempdiam;
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  const RPoint oldpoint = *( inst->GetPoint(m_dlg->m_selected_index) );
  RPoint pt = m_dlg->m_converter.ClientToImage(CPoint(point.x,point.y),root->GetPrimaryWindow());

  // move point to a new location. call the Undo version of this command.
  m_dlg->m_controller.C_MovePoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.x, pt.y );
  
  m_dlg->m_controller.C_ChangeWindowOfPoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.window );

  // check if diameter is on relevant root segment, if it isn't, do nothing.
  if ( (m_dlg->section_start_point_index == m_dlg->m_selected_index) || (m_dlg->section_start_point_index == (m_dlg->m_selected_index-1) ) )
  {
    //get other point of segment
    const RPoint* otherpoint; 
    //get new diameter position if neccesary
    if ( m_dlg->section_start_point_index == m_dlg->m_selected_index )
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index + 1);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * m_dlg->diameter_position_ratio;
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * m_dlg->diameter_position_ratio;
    }
    else
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * (1 - m_dlg->diameter_position_ratio);
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * (1 - m_dlg->diameter_position_ratio);
    }
    tempdiam.window = diam->r_point.window;
    m_dlg->m_controller.C_MoveDiameter(0, m_dlg->m_selected_root_id, tempdiam);
  }
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_MOVINGRPOINT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  SetCursor(m_dlg->m_cur_sizeall);
  RPoint tempdiam;
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  const RPoint oldpoint = *( inst->GetPoint(m_dlg->m_selected_index) );
  RPoint pt = m_dlg->m_converter.ClientToImage(CPoint(point.x,point.y),root->GetPrimaryWindow());

  // move point to a new location. call the Undo version of this command.
  m_dlg->m_controller.C_MovePoint_U( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.x, pt.y, &(m_dlg->m_previous_root_for_undo));
  
  m_dlg->m_controller.C_ChangeWindowOfPoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.window );

  // check if diameter is on relevant root segment, if it isn't, do nothing.
  if ( (m_dlg->section_start_point_index == m_dlg->m_selected_index) || (m_dlg->section_start_point_index == (m_dlg->m_selected_index-1) ) )
  {
    //get other point of segment
    const RPoint* otherpoint; 
    //get new diameter position if neccesary
    if ( m_dlg->section_start_point_index == m_dlg->m_selected_index )
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index + 1);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * m_dlg->diameter_position_ratio;
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * m_dlg->diameter_position_ratio;
    }
    else
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * (1 - m_dlg->diameter_position_ratio);
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * (1 - m_dlg->diameter_position_ratio);
    }
    tempdiam.window = diam->r_point.window;
    m_dlg->m_controller.C_MoveDiameter(0, m_dlg->m_selected_root_id, tempdiam);
  }

  m_dlg->SetMode(MODE_ROOTSELECTED);          
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_MOVINGRPOINT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// does nothing
}

void ModeHandlerMODE_MOVINGRPOINT::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// does nothing
}

CString ModeHandlerMODE_MOVINGRPOINT::GetStatusText() 
{
	return "Moving point, left click to finish"; 
}


// created a new mode for add point. earlier, OnAddPoint from RootflyDlg set the
// mode to MOVINGRPOINT. this meant that the Undo functionality was unable to
// distinguish between a point being moved versus a new point being created and moved.
// thus, MOVINGRPOINT and ADDPOINT are almost the same. the exception is that
// the Undo function for MovePoint is called in MOVINGRPOINT, whereas the non-Undo
// version is called in ADDPOINT. - (Ninad Pradhan 04/25/08)
void ModeHandlerMODE_ADDPOINT::OnMouseMove(UINT nFlags, CPoint point) 
{
  SetCursor(m_dlg->m_cur_sizeall);
  RPoint tempdiam;
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  const RPoint oldpoint = *( inst->GetPoint(m_dlg->m_selected_index) );
  RPoint pt = m_dlg->m_converter.ClientToImage(CPoint(point.x,point.y),root->GetPrimaryWindow());

  // call the non-Undo version of MovePoint here.
  m_dlg->m_controller.C_MovePoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.x, pt.y );
  
  m_dlg->m_controller.C_ChangeWindowOfPoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.window );

  // check if diameter is on relevant root segment, if it isn't, do nothing.
  if ( (m_dlg->section_start_point_index == m_dlg->m_selected_index) || (m_dlg->section_start_point_index == (m_dlg->m_selected_index-1) ) )
  {
    //get other point of segment
    const RPoint* otherpoint; 
    //get new diameter position if neccesary
    if ( m_dlg->section_start_point_index == m_dlg->m_selected_index )
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index + 1);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * m_dlg->diameter_position_ratio;
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * m_dlg->diameter_position_ratio;
    }
    else
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * (1 - m_dlg->diameter_position_ratio);
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * (1 - m_dlg->diameter_position_ratio);
    }
    tempdiam.window = diam->r_point.window;
    m_dlg->m_controller.C_MoveDiameter(0, m_dlg->m_selected_root_id, tempdiam);
  }
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_ADDPOINT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  m_dlg->SetMode(MODE_ROOTSELECTED);          
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_ADDPOINT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// does nothing
}

void ModeHandlerMODE_ADDPOINT::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// does nothing
}

CString ModeHandlerMODE_ADDPOINT::GetStatusText() 
{
	return "Moving point, left click to finish"; 
}


//
void ModeHandlerMODE_EXTENDINGENDPOINT::OnMouseMove(UINT nFlags, CPoint point) 
{
  CPoint head = m_dlg->m_converter.ImageToClient(*(m_dlg->m_current_root_being_drawn.GetPoint(0)));
  const vector<RPoint> *points = m_dlg->m_current_root_being_drawn.GetAllPoints();    
  CPoint tail = m_dlg->m_converter.ImageToClient(*(m_dlg->m_current_root_being_drawn.GetPoint(points->size()-1)));

  double delta_x, delta_y;
  delta_x = point.x - head.x;
  delta_y = point.y - head.y;
  double distance_to_head = delta_x * delta_x + delta_y * delta_y;
  delta_x = point.x - tail.x;
  delta_y = point.y - tail.y;
  double distance_to_tail = delta_x * delta_x + delta_y * delta_y;
  m_dlg->m_extending_from_tail = (distance_to_tail < distance_to_head) ? true : false;
  m_dlg->m_extending_from_head = (distance_to_tail < distance_to_head) ? false : true;
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_EXTENDINGENDPOINT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube() );
  assert(tube); if (!tube) return;
  const Root *tempr = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(tempr);  if (!tempr)  return;
  const RootInstance *inst = tempr->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  RPoint pt = m_dlg->m_converter.ClientToImage(CPoint(point.x,point.y),tempr->GetPrimaryWindow());

  const vector<Root> *roots = tube->GetAllRoots();
  assert(roots); if (!roots) return;

  for (int i = 0; i < roots->size(); i++)
  {
    const Root& root = roots->at(i);
    int id = root.GetID();
    if (id == m_dlg->m_selected_root_id)
    {
      const RootInstance *inst = root.GetRootInstance(m_dlg->m_app_data->GetSession());  
      if (!inst) return;
      const std::vector<RPoint> *old_line = inst->GetAllPoints();
      RPoint *rpt = m_dlg->m_controller.C_CreatePoint(id);
      if (m_dlg->m_extending_from_tail)
      {
        *rpt = pt;
        m_dlg->m_extending_from_tail = false;
      }
      if (m_dlg->m_extending_from_head)
      {
        for (int j = old_line->size(); j >= 0; j--)
        {
          RPoint temp_point = (j>0) ? old_line->at(j-1) : pt;
          m_dlg->m_controller.C_MovePoint(j, id, temp_point.x, temp_point.y);
          m_dlg->m_controller.C_ChangeWindowOfPoint(j, id, temp_point.window);
        }
        m_dlg->m_extending_from_head = false;
      }
      break;
    }
  } 
  m_dlg->m_current_root_being_drawn.ClearAll();
  m_dlg->SetMode(MODE_ROOTSELECTED);
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_EXTENDINGENDPOINT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	//Double Click not used by EXTENDINGENDPOINT
}

void ModeHandlerMODE_EXTENDINGENDPOINT::OnRButtonDown(UINT nFlags, CPoint point) 
{
    m_dlg->SetMode(MODE_ROOTSELECTED);
    m_dlg->m_extending_from_tail = false;
    m_dlg->m_extending_from_head = false;
    m_dlg->m_current_root_being_drawn.ClearAll();
    m_dlg->ReDraw(1,0);
}

CString ModeHandlerMODE_EXTENDINGENDPOINT::GetStatusText() 
{ 
  return "Left click to extend endpoint";
}

void ModeHandlerMODE_IMAGEDISPLAYED::OnMouseMove(UINT nFlags, CPoint point) 
{
  int window = m_dlg->m_app_data->GetWindow();
  RPoint pt = m_dlg->m_converter.ClientToImage( CPoint(point.x,point.y),window);
  int tempRootID;	
  RDiameter nearest_point;
  m_dlg->FindNearestPoint( pt.x, pt.y, &nearest_point);      
  int diameter_selected = m_dlg->FindNearestDiameter( pt.x, pt.y );
  if ( nearest_point.radius < 0 && diameter_selected < 0)
  {
    m_dlg->m_selected_root_id = -1;
    if ( m_dlg->m_over_root )
    {
      m_dlg->m_over_root = false; 
      m_dlg->ReDraw(1, 0);          
    }
  }
  else 
  { 
	  const Tube *tube = m_dlg->m_exp_data->GetTube( m_dlg->m_app_data->GetTube() );
	  if (!tube)  return;

    if (nearest_point.radius >= 0)
	  {
	    tempRootID = nearest_point.r_point.window;
	    const Root *root = tube->GetRoot(tempRootID);
	    if (!root)  return;
	    const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
	    if (!inst)  return;
	    if ((inst->IsAlive()) || (m_dlg->m_checkbox_show_dead_roots.GetCheck() == BST_CHECKED)) m_dlg->m_selected_root_id = nearest_point.r_point.window; 
	  }
    else
	  {
	    tempRootID = diameter_selected;
	    const Root *root = tube->GetRoot(tempRootID);
	    if (!root)  return;
	    const RootInstance *inst2 = root->GetRootInstance(m_dlg->m_app_data->GetSession());
	    if (!inst2)  return;
      if ((inst2->IsAlive()) || (m_dlg->m_checkbox_show_dead_roots.GetCheck() == BST_CHECKED)) m_dlg->m_selected_root_id =  diameter_selected;   
	  }
    
    if ( !m_dlg->m_over_root )
    {
	    m_dlg->m_over_root = true;
      m_dlg->ReDraw(1, 0);
    }
    else
    {
      m_dlg->ReDraw(1, 0);    
    }
  }
}
void ModeHandlerMODE_IMAGEDISPLAYED::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_dlg->m_over_root)
      {
        m_dlg->SetMode(MODE_ROOTSELECTED);            
        m_dlg->ReDraw(1, 0);
      }
}

void ModeHandlerMODE_IMAGEDISPLAYED::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// Is not used by this function
}

void ModeHandlerMODE_IMAGEDISPLAYED::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// Is not used by this function
}

CString ModeHandlerMODE_IMAGEDISPLAYED::GetStatusText() 
{ 
  return "Ready to annotate";
}

void ModeHandlerMODE_SIZINGDIAMETER::OnMouseMove(UINT nFlags, CPoint point)
{
  vector<int> window_list;
  m_dlg->m_current_root_being_drawn.GetWindowNumbers(&window_list);
  RPoint temp = m_dlg->m_converter.ClientToImage(point);
  temp = m_dlg->m_converter.ChangeWindow(temp,window_list[0]);

  RDiameter *rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0);
  rdm->radius = sqrt( pow(( temp.x - rdm->r_point.x),2) + pow(( temp.y - rdm->r_point.y),2) ); 
  m_dlg->ReDraw(1, 0); 
}

void ModeHandlerMODE_SIZINGDIAMETER::OnLButtonDown(UINT nFlags, CPoint point2)
{
  // instead of doing all that below, call new creatroot function that
  // takes in a reference to the rootinstance, and creates the new
  // instance for that root
  const std::vector<RPoint> *line; 
  line = m_dlg->m_current_root_being_drawn.GetAllPoints();    
  if (line->size() == 0)  return;
  m_dlg->m_controller.C_CreateRoot( line->at(0).window, m_dlg->m_current_root_being_drawn, m_dlg->GetConditionDefault() );

  /*
  RDiameter *rd = m_dlg->m_current_root_being_drawn.GetDiameter(0);
  const std::vector<RPoint> *line;  
  line = m_dlg->m_current_root_being_drawn.GetAllPoints();    
  if (line->size() == 0)  return;
  Root *root = m_dlg->m_controller.C_CreateRoot( line->at(0).window );    
  RootInstance *inst = m_dlg->m_controller.C_CreateRootInstance( root->GetID() );  
  RPoint *rpt;
  vector<RPoint>::const_iterator iter;

  int tempwindow = line->at(0).window;
  RPoint temp;  

  //*inst = m_dlg->m_current_root_being_drawn;

 //Replaced all this stuff with a single call to assignment operator above -- STB 4/22/08
 //didn't work - Sebastian Roos

  //makes sure all points are with respect to the parent window
  for ( iter = line->begin(); iter != line->end(); iter++ )
  {
    temp = *iter;
    temp = m_dlg->m_converter.ChangeWindow(temp,tempwindow);
    rpt = inst->CreatePoint();
    rpt->x = temp.x;
    rpt->y = temp.y;
    rpt->window = temp.window;     
  }
  RDiameter *rd2 = m_dlg->m_controller.C_CreateDiameter( root->GetID() );

  temp = rd->r_point;
  temp = m_dlg->m_converter.ChangeWindow(temp,tempwindow);
  rd2->r_point.x = temp.x;
  rd2->r_point.y = temp.y;
  rd2->r_point.window = temp.window;
  rd2->radius = rd->radius;
  */

  // sets the default condition code for the root
  // this is now done in create root
  // m_dlg->SetConditionDefault(root);

  m_dlg->m_selected_root_id = -1;
  m_dlg->SetMode(MODE_IMAGEDISPLAYED);
  m_dlg->m_current_root_being_drawn.ClearAll();
  m_dlg->ReDraw(1, 0);
}

// This function does not need to do anything -- STB
void ModeHandlerMODE_SIZINGDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point)
{
  // instead of doing all that below, call new creatroot function that
  // takes in a reference to the rootinstance, and creates the new
  // instance for that root
  //const std::vector<RPoint> *line; 
  //line = m_dlg->m_current_root_being_drawn.GetAllPoints();    
  //if (line->size() == 0)  return;
  //m_dlg->m_controller.C_CreateRoot( line->at(0).window, m_dlg->m_current_root_being_drawn, m_dlg->GetConditionDefault() );

	/*
	std::vector<RPoint>::const_iterator r_iter;
	const std::vector<RPoint> *line = m_dlg->m_current_root_being_drawn.GetAllPoints();
	RPoint *rpt;
	RPoint conv_point, temp = m_dlg->FindNearestPointOnRoot( conv_point, m_dlg->m_current_root_being_drawn );
	RDiameter *rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0), *rd2;
	const Root *root = m_dlg->m_controller.C_CreateRoot( line->at(0).window );
	RootInstance *r_inst = m_dlg->m_controller.C_CreateRootInstance( root->GetID() );

	assert( r_inst );
    assert(line->size() > 0);
    if (line->size() == 0)  return;

    rdm->r_point.x = temp.x;
    rdm->r_point.y = temp.y;
    rdm->r_point.window = temp.window;
    rdm->radius = 8;
  
	for ( r_iter = line->begin(); r_iter != line->end(); r_iter++ )
    {
        rpt = r_inst->CreatePoint();
        rpt->x = r_iter->x;
        rpt->y = r_iter->y;
        rpt->window = r_iter->window;
    }
    rd2 = m_dlg->m_controller.C_CreateDiameter( root->GetID() );
	rd2 = rdm;
	*/
      
    // setting condition default when creating root now
    // m_dlg->SetConditionDefault(root);

    //m_dlg->SetMode(MODE_IMAGEDISPLAYED);
    //m_dlg->m_current_root_being_drawn.ClearAll();
    //m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_SIZINGDIAMETER::OnRButtonDown(UINT nFlags, CPoint point)
{
}

CString ModeHandlerMODE_SIZINGDIAMETER::GetStatusText() 
{ 
  CString str;
  str += _T("Left click to set diameter size");
  return str; 
}

void ModeHandlerMODE_NOIMAGEDISPLAYED::OnMouseMove(UINT nFlags, CPoint point)
{
  //No functionality.
}

void ModeHandlerMODE_NOIMAGEDISPLAYED::OnLButtonDown(UINT nFlags, CPoint point)
{
  //No functionality.
}

void ModeHandlerMODE_NOIMAGEDISPLAYED::OnLButtonDblClk(UINT nFlags, CPoint point)
{
  //No functionality.
}

void ModeHandlerMODE_NOIMAGEDISPLAYED::OnRButtonDown(UINT nFlags, CPoint point)
{
  //No functionality.
}

CString ModeHandlerMODE_NOIMAGEDISPLAYED::GetStatusText()
{
  CString str;
  str += _T("No Image Displayed");
  return str; 
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnMouseMove(UINT nFlags, CPoint point2)
{
  SetCursor(m_dlg->m_cur_sizens);    
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  RPoint point = m_dlg->m_converter.ClientToImage( CPoint(point2.x,point2.y),root->GetPrimaryWindow());
  {        
    int delta_x, delta_y;        
    delta_x = diam->r_point.x - point.x;
    delta_y = diam->r_point.y - point.y;
    double new_radius = sqrt(pow(delta_x,2)+pow(delta_y,2));
    m_dlg->m_controller.C_ResizeDiameter(0, m_dlg->m_selected_root_id, new_radius);      
  }
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnLButtonDown(UINT nFlags, CPoint point2)
{
  SetCursor(m_dlg->m_cur_sizens);    
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  RPoint point = m_dlg->m_converter.ClientToImage( CPoint(point2.x,point2.y),root->GetPrimaryWindow());
  {        
    int delta_x, delta_y;        
    delta_x = diam->r_point.x - point.x;
    delta_y = diam->r_point.y - point.y;
    double new_radius = sqrt(pow(delta_x,2)+pow(delta_y,2));
    m_dlg->m_controller.C_ResizeDiameter_U(0, m_dlg->m_selected_root_id, m_dlg->m_previous_radius_for_undo, new_radius);      
  }
  m_dlg->SetMode(MODE_ROOTSELECTED);
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	//NOP
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnRButtonDown(UINT nFlags, CPoint point)
{
	//NOP
}

CString ModeHandlerMODE_RESIZINGDIAMETER::GetStatusText()
{
	return "Resizing diameter, left click to finish";
}
