#if !defined(AFX_SESSIONDATESDLG_H__C9C0F3D7_C05C_4BF8_B040_30AA237F5EA8__INCLUDED_)
#define AFX_SESSIONDATESDLG_H__C9C0F3D7_C05C_4BF8_B040_30AA237F5EA8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SessionDatesDlg.h : header file
//

#include <vector>
#include <string>
#include "ImageFileFormat.h"

/////////////////////////////////////////////////////////////////////////////
// SessionDatesDlg dialog

class SessionDatesDlg : public CDialog
{
// Construction
public:
	SessionDatesDlg(CWnd* pParent = NULL);   // standard constructor
  void SetMaxSessions(int max) { m_max_sessions = max; }
  const std::vector<Date> GetSessionDates();
  void SetSessionDates(const std::vector<Date> dates);
  static CString GetStringFromDate(Date date);

// Dialog Data
	//{{AFX_DATA(SessionDatesDlg)
	enum { IDD = IDD_SESSION_DATES_DLG };
	CEdit	m_edit_year;
	CEdit	m_edit_month;
	CEdit	m_edit_day;
	CListBox	m_list_dates;
	CListBox	m_list_sessions;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SessionDatesDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

  int m_max_sessions; 
  int m_count;  
  vector<Date> m_dates;
  bool ValidDay();
  bool ValidMonth();
  bool ValidYear();
  void UpdateEditBoxes(int index);
	// Generated message map functions
	//{{AFX_MSG(SessionDatesDlg)
	virtual void OnOK();
	afx_msg void OnSelchangeListSessions();
	afx_msg void OnSelchangeListDates();
	virtual BOOL OnInitDialog();
	afx_msg void OnUpdateEditMonth();
	afx_msg void OnUpdateEditYear();
	afx_msg void OnUpdateEditDay();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SESSIONDATESDLG_H__C9C0F3D7_C05C_4BF8_B040_30AA237F5EA8__INCLUDED_)
